'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _MediaUtilities = require('./MediaUtilities');

var MediaUtilities = _interopRequireWildcard(_MediaUtilities);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BaseComponent = function () {
  function BaseComponent(driverContainer, friendlyName, expectedElementSelector, url) {
    _classCallCheck(this, BaseComponent);

    this.driverContainer = driverContainer;
    this.expectedElementSelector = expectedElementSelector;
    this.friendlyName = friendlyName;
    this.url = url;
  }

  _createClass(BaseComponent, [{
    key: 'initialize',
    value: function initialize() {
      var _this = this;
      return _this.driverContainer.driver.get(_this.url).then(function () {
        return _this.waitForPage();
      });
    }
  }, {
    key: 'rest',
    value: function rest() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      return this.driverContainer.driverUtilities.rest(value);
    }
  }, {
    key: 'scrollToTop',
    value: function scrollToTop() {
      return this.driverContainer.driverUtilities.scrollToTop();
    }
  }, {
    key: 'waitForPage',
    value: function waitForPage() {
      return this.driverContainer.driverUtilities.waitTillPresentAndDisplayed(this.expectedElementSelector);
    }
  }, {
    key: 'displayed',
    value: function displayed() {
      return this.driverContainer.driverUtilities.isEventuallyPresentAndDisplayed(this.expectedElementSelector);
    }
  }, {
    key: 'title',
    value: function title() {
      return this.driverContainer.driver.getTitle();
    }
  }, {
    key: 'urlDisplayed',
    value: function urlDisplayed() {
      return this.driverContainer.driver.getCurrentUrl();
    }
  }, {
    key: 'checkForConsoleErrors',
    value: function checkForConsoleErrors() {
      return this.driverContainer.driverUtilities.checkForConsoleErrors();
    }
  }, {
    key: 'checkWindowInEyes',
    value: function checkWindowInEyes() {
      var step = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";

      var name = this.friendlyName;
      if (step) name += " - " + step;
      return this.driverContainer.eyes.checkWindow(name);
    }
  }, {
    key: 'takeScreenShotToFile',
    value: function takeScreenShotToFile() {
      var _this = this;
      if (_this.driverContainer.config.saveAllScreenshots === true) {
        var _ret = function () {
          var prefix = !_this.friendlyName ? 'BaseComponent-' + _this.driverContainer.config.browserType : _this.friendlyName + '-' + _this.driverContainer.config.browserType;
          try {
            return {
              v: _this.driverContainer.driver.takeScreenshot().then(function (data) {
                MediaUtilities.writeScreenshot(data, prefix);
              })
            };
          } catch (e) {
            console.log('Error when taking screenshot in BaseComponent: \'' + e + '\'');
          }
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }
    }
  }]);

  return BaseComponent;
}();

exports.default = BaseComponent;