'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _seleniumWebdriver = require('selenium-webdriver');

var _seleniumWebdriver2 = _interopRequireDefault(_seleniumWebdriver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DriverUtilities = function () {
  function DriverUtilities(config, logger, driver, timeout) {
    _classCallCheck(this, DriverUtilities);

    this.config = config;
    this.logger = logger;
    this.driver = driver;
    this.defaultTimeout = timeout;
  }

  // Refactor 1


  _createClass(DriverUtilities, [{
    key: 'rest',
    value: function rest() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      var _this = this;
      var restValue = value || _this.config.sleepConstant;
      return _this.driver.sleep(restValue);
    }

    // Refactor 1

  }, {
    key: 'scrollToElementObject',
    value: function scrollToElementObject(element) {
      var top = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var _this = this;
      if (top) {
        return _this.rest().then(function () {
          return _this.driver.executeScript("arguments[0].scrollIntoView(true);", element);
        }).then(function () {
          return _this.rest();
        }).then(function () {
          return _this.driver.executeScript("window.scrollBy(0," + _this.config.scrollBuffer + ")");
        });
      } else {
        return _this.rest().then(function () {
          return _this.driver.executeScript("arguments[0].scrollIntoView(false);", element);
        }).then(function () {
          return _this.rest();
        }).then(function () {
          return _this.driver.executeScript("window.scrollBy(0," + _this.config.scrollBuffer + ")");
        });
      }
    }

    // Refactor 1

  }, {
    key: 'clickElementObject',
    value: function clickElementObject(element) {
      var _this = this;
      return _this.rest().then(function () {
        return element.click();
      });
    }

    // Refactor 1

  }, {
    key: 'scrollToElement',
    value: function scrollToElement(selector) {
      var top = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var _this = this;
      return _this.driver.findElement(selector).then(function (element) {
        return _this.scrollToElementObject(element, top);
      }, function () {
        return Promise.resolve();
      });
    }

    // Refactor 1

  }, {
    key: 'scrollToTop',
    value: function scrollToTop() {
      var _this = this;
      return _this.rest().then(function () {
        return _this.driver.executeScript("window.scrollTo(0, 0);");
      }).then(function () {
        return _this.rest();
      });
    }

    // Refactor 1

  }, {
    key: '_scrollToAndClickElementObject',
    value: function _scrollToAndClickElementObject(element) {
      var _this = this;
      return _this.scrollToElementObject(element).then(function () {
        return _this.clickElementObject(element);
      });
    }

    // Refactor 1

  }, {
    key: '_scrollToAndClickElementObjects',
    value: function _scrollToAndClickElementObjects(elements) {
      var _this = this;
      if (elements.length === 0) return Promise.resolve();
      return _this._scrollToAndClickElementObject(elements[0]).then(function () {
        return _this.rest();
      }).then(function () {
        elements.shift();
        return _this._scrollToAndClickElementObjects(elements);
      });
    }

    // Refactor 1

  }, {
    key: 'clickAllWhenClickable',
    value: function clickAllWhenClickable(selector) {
      var _this = this;
      return _this.driver.wait(function () {
        return _this.driver.findElements(selector).then(function (elements) {
          return _this._scrollToAndClickElementObjects(elements);
        }, function () {
          // None found, but thats okay
          return Promise.resolve();
        }).then(function () {
          return true;
        });
      }, _this.defaultTimeout, 'Timed out waiting for all elements with ' + selector.using + ' of \'' + selector.value + '\' to be clickable');
    }

    // Refactor 1

  }, {
    key: 'clickWhenClickable',
    value: function clickWhenClickable(selector) {
      var _this = this;
      return _this.driver.wait(function () {
        return _this.driver.findElement(selector).then(function (element) {
          return _this._scrollToAndClickElementObject(element);
        }).then(function () {
          return true;
        });
      }, _this.defaultTimeout, 'Timed out waiting for element with ' + selector.using + ' of \'' + selector.value + '\' to be clickable');
    }

    // Refactor 1

  }, {
    key: 'clickIfPresent',
    value: function clickIfPresent(selector) {
      var _this = this;
      return _this.driver.findElement(selector).then(function (element) {
        return _this.clickElementObject(element);
      }, function () {
        return Promise.resolve();
      });
    }

    // Refactor 1

  }, {
    key: 'scrollToAndClickIfPresent',
    value: function scrollToAndClickIfPresent(selector) {
      var _this = this;
      return _this.driver.findElement(selector).then(function (element) {
        return _this._scrollToAndClickElementObject(element);
      }, function () {
        return Promise.resolve();
      });
    }

    // Old needs to be refactored I guess...

  }, {
    key: 'followLinkWhenFollowable',
    value: function followLinkWhenFollowable(selector) {
      var _this = this;
      return _this.driver.wait(function () {
        return _this.driver.findElement(selector).then(function (element) {
          return element.getAttribute('href').then(function (href) {
            _this.driver.get(href);
            return true;
          }, function () {
            return false;
          });
        }, function () {
          return false;
        });
      }, _this.defaultTimeout, 'Timed out waiting for link with ' + selector.using + ' of \'' + selector.value + '\' to be followable');
    }
  }, {
    key: 'waitTillPresentAndDisplayed',
    value: function waitTillPresentAndDisplayed(selector) {
      var _this = this;
      return _this.driver.wait(function () {
        return _this.driver.findElement(selector).then(function (element) {
          return element.isDisplayed().then(function () {
            return true;
          }, function () {
            return false;
          });
        }, function () {
          return false;
        });
      }, _this.defaultTimeout, 'Timed out waiting for element with ' + selector.using + ' of \'' + selector.value + '\' to be present and displayed');
    }
  }, {
    key: 'isEventuallyPresentAndDisplayed',
    value: function isEventuallyPresentAndDisplayed(selector) {
      var _this = this;
      return _this.driver.wait(function () {
        return _this.driver.findElement(selector).then(function (element) {
          return element.isDisplayed().then(function () {
            return true;
          }, function () {
            return false;
          });
        }, function () {
          return false;
        });
      }, _this.defaultTimeout).then(function (shown) {
        return shown;
      }, function () {
        return false;
      });
    }
  }, {
    key: 'waitForFieldClearable',
    value: function waitForFieldClearable(selector) {
      var _this = this;
      return _this.driver.wait(function () {
        return _this.driver.findElement(selector).then(function (element) {
          return element.clear().then(function () {
            return element.getAttribute('value').then(function (value) {
              return value === '';
            });
          }, function () {
            return false;
          });
        }, function () {
          return false;
        });
      }, _this.defaultTimeout, 'Timed out waiting for element with ' + selector.using + ' of \'' + selector.value + '\' to be clearable');
    }
  }, {
    key: 'setWhenSettable',
    value: function setWhenSettable(selector, value) {
      var secureValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      var _this = this;
      var logValue = secureValue === true ? '*********' : value;
      return _this.driver.wait(function () {
        return _this.driver.findElement(selector).then(function (element) {
          _this.waitForFieldClearable(selector);
          return element.sendKeys(value).then(function () {
            return element.getAttribute('value').then(function (actualValue) {
              return actualValue === value;
            });
          }, function () {
            return false;
          });
        }, function () {
          return false;
        });
      }, _this.defaultTimeout, 'Timed out waiting for element with ' + selector.using + ' of \'' + selector.value + '\' to be settable to: \'' + logValue + '\'');
    }
  }, {
    key: 'setCheckbox',
    value: function setCheckbox(selector) {
      var _this = this;
      return _this.driver.findElement(selector).then(function (checkbox) {
        checkbox.getAttribute('checked').then(function (checked) {
          if (checked !== 'true') {
            return _this.clickWhenClickable(selector);
          }
        });
      });
    }
  }, {
    key: 'unsetCheckbox',
    value: function unsetCheckbox(selector) {
      var _this = this;
      return _this.driver.findElement(selector).then(function (checkbox) {
        checkbox.getAttribute('checked').then(function (checked) {
          if (checked === 'true') {
            return _this.clickWhenClickable(selector);
          }
        });
      });
    }

    /**
     * Check whether an image is actually visible - that is rendered to the screen - not just having a reference in the DOM
     * @param {WebElement} webElement - Element to search for
     * @returns {Promise} - Resolved when the script is done executing
     */

  }, {
    key: 'imageVisible',
    value: function imageVisible(webElement) {
      var _this = this;
      return _this.driver.executeScript('return (typeof arguments[0].naturalWidth!=\"undefined\" && arguments[0].naturalWidth>0)', webElement);
    }
  }, {
    key: 'checkForConsoleErrors',
    value: function checkForConsoleErrors() {
      var _this = this;
      if (_this.config.checkForConsoleErrors === true) {
        _this.driver.manage().logs().get('browser').then(function (logs) {
          if (logs.length > 0) {
            (0, _lodash.forEach)(logs, function (log) {
              // Ignore chrome cast errors in Chrome - http://stackoverflow.com/questions/24490323/google-chrome-cast-sender-error-if-chrome-cast-extension-is-not-installed-or-usi/26095117#26095117
              if (log.message.indexOf('cast_sender.js') === -1) {
                _this.driver.getCurrentUrl().then(function (url) {
                  _this.logger.warn('Found console error: "' + log.message + '" on url \'' + url + '\'', true);
                });
              }
            });
          }
        });
      }
    }
  }]);

  return DriverUtilities;
}();

module.exports.DriverUtilities = DriverUtilities;