// Example/Template of a logger

'use strict';

class SimpleLogger {
  constructor() {
    this.messages = [];
    this.runName = "";
  }
  
  warn(message, suppressDuplicateMessages = false) {
    if (suppressDuplicateMessages !== false && this.messages.indexOf(message) !== -1) return;
  
    let sentMessage = this.runName + ": " + message;
    // Log the message to the JS Console
    console.log(sentMessage);
    
    // Some custom code to send a message to external systems, like:
    // Slack, Discord, HipChat, etc.
    
    // Add message to history
    this.messages.push(message);
  }
}
module.exports.SimpleLogger = SimpleLogger;
